diff -r fb51f5b4aa4c trytond/tests/test_fields.py
--- a/trytond/tests/test_fields.py	Mon Sep 24 11:36:39 2012 +0200
+++ b/trytond/tests/test_fields.py	Mon Sep 24 20:36:36 2012 +0200
@@ -628,221 +595,208 @@
         '''
         with Transaction().start(DB_NAME, USER,
                 context=CONTEXT) as transaction:
-            numeric1_id = self.numeric.create({
-                'numeric': Decimal('1.1'),
-                })
-            self.assert_(numeric1_id)
-
-            numeric1 = self.numeric.read(numeric1_id, ['numeric'])
-            self.assert_(numeric1['numeric'] == Decimal('1.1'))
-
-            numeric_ids = self.numeric.search([
-                ('numeric', '=', Decimal('1.1')),
-                ])
-            self.assert_(numeric_ids == [numeric1_id])
-
-            numeric_ids = self.numeric.search([
-                ('numeric', '=', Decimal('0')),
-                ])
-            self.assert_(numeric_ids == [])
-
-            numeric_ids = self.numeric.search([
-                ('numeric', '!=', Decimal('1.1')),
-                ])
-            self.assert_(numeric_ids == [])
-
-            numeric_ids = self.numeric.search([
-                ('numeric', '!=', Decimal('0')),
-                ])
-            self.assert_(numeric_ids == [numeric1_id])
-
-            numeric_ids = self.numeric.search([
-                ('numeric', 'in', [Decimal('1.1')]),
-                ])
-            self.assert_(numeric_ids == [numeric1_id])
-
-            numeric_ids = self.numeric.search([
-                ('numeric', 'in', [Decimal('0')]),
-                ])
-            self.assert_(numeric_ids == [])
-
-            numeric_ids = self.numeric.search([
-                ('numeric', 'in', []),
-                ])
-            self.assert_(numeric_ids == [])
-
-            numeric_ids = self.numeric.search([
-                ('numeric', 'not in', [Decimal('1.1')]),
-                ])
-            self.assert_(numeric_ids == [])
-
-            numeric_ids = self.numeric.search([
-                ('numeric', 'not in', [Decimal('0')]),
-                ])
-            self.assert_(numeric_ids == [numeric1_id])
-
-            numeric_ids = self.numeric.search([
-                ('numeric', 'not in', []),
-                ])
-            self.assert_(numeric_ids == [numeric1_id])
-
-            numeric_ids = self.numeric.search([
-                ('numeric', '<', Decimal('5')),
-                ])
-            self.assert_(numeric_ids == [numeric1_id])
-
-            numeric_ids = self.numeric.search([
-                ('numeric', '<', Decimal('-5')),
-                ])
-            self.assert_(numeric_ids == [])
-
-            numeric_ids = self.numeric.search([
-                ('numeric', '<', Decimal('1.1')),
-                ])
-            self.assert_(numeric_ids == [])
-
-            numeric_ids = self.numeric.search([
-                ('numeric', '<=', Decimal('5')),
-                ])
-            self.assert_(numeric_ids == [numeric1_id])
-
-            numeric_ids = self.numeric.search([
-                ('numeric', '<=', Decimal('-5')),
-                ])
-            self.assert_(numeric_ids == [])
-
-            numeric_ids = self.numeric.search([
-                ('numeric', '<=', Decimal('1.1')),
-                ])
-            self.assert_(numeric_ids == [numeric1_id])
-
-            numeric_ids = self.numeric.search([
-                ('numeric', '>', Decimal('5')),
-                ])
-            self.assert_(numeric_ids == [])
-
-            numeric_ids = self.numeric.search([
-                ('numeric', '>', Decimal('-5')),
-                ])
-            self.assert_(numeric_ids == [numeric1_id])
-
-            numeric_ids = self.numeric.search([
-                ('numeric', '>', Decimal('1.1')),
-                ])
-            self.assert_(numeric_ids == [])
-
-            numeric_ids = self.numeric.search([
-                ('numeric', '>=', Decimal('5')),
-                ])
-            self.assert_(numeric_ids == [])
-
-            numeric_ids = self.numeric.search([
-                ('numeric', '>=', Decimal('-5')),
-                ])
-            self.assert_(numeric_ids == [numeric1_id])
-
-            numeric_ids = self.numeric.search([
-                ('numeric', '>=', Decimal('1.1')),
-                ])
-            self.assert_(numeric_ids == [numeric1_id])
-
-            numeric2_id = self.numeric.create({
-                'numeric': Decimal('0'),
-                })
-            self.assert_(numeric2_id)
-
-            numeric2 = self.numeric.read(numeric2_id, ['numeric'])
-            self.assert_(numeric2['numeric'] == Decimal('0'))
-
-            numeric_ids = self.numeric.search([
-                ('numeric', '=', Decimal('0')),
-                ])
-            self.assert_(numeric_ids == [numeric2_id])
-
-            numeric_ids = self.numeric.search([
-                ('numeric', 'in', [Decimal('0'), Decimal('1.1')]),
-                ])
-            self.assert_(numeric_ids == [numeric1_id, numeric2_id])
-
-            numeric_ids = self.numeric.search([
-                ('numeric', 'not in', [Decimal('0'), Decimal('1.1')]),
-                ])
-            self.assert_(numeric_ids == [])
-
-            numeric3_id = self.numeric.create({})
-            self.assert_(numeric3_id)
-
-            numeric3 = self.numeric.read(numeric3_id, ['numeric'])
-            self.assert_(numeric3['numeric'] is None)
-
-            numeric4_id = self.numeric_default.create({})
-            self.assert_(numeric4_id)
-
-            numeric4 = self.numeric_default.read(numeric4_id, ['numeric'])
-            self.assert_(numeric4['numeric'] == Decimal('5.5'))
-
-            self.numeric.write(numeric1_id, {
-                'numeric': Decimal('0'),
-                })
-            numeric1 = self.numeric.read(numeric1_id, ['numeric'])
-            self.assert_(numeric1['numeric'] == Decimal('0'))
-
-            self.numeric.write(numeric2_id, {
-                'numeric': Decimal('1.1'),
-                })
-            numeric2 = self.numeric.read(numeric2_id, ['numeric'])
-            self.assert_(numeric2['numeric'] == Decimal('1.1'))
-
-            self.failUnlessRaises(Exception, self.numeric.create, {
-                'numeric': 'test',
-                })
-
-            self.failUnlessRaises(Exception, self.numeric.write, numeric1_id, {
-                'numeric': 'test',
-                })
+            numeric1 = self.numeric.create({
+                    'numeric': Decimal('1.1'),
+                    })
+            self.assert_(numeric1)
+            self.assertEqual(numeric1.numeric, Decimal('1.1'))
+
+            numerics = self.numeric.search([
+                    ('numeric', '=', Decimal('1.1')),
+                    ])
+            self.assertEqual(numerics, [numeric1])
+
+            numerics = self.numeric.search([
+                    ('numeric', '=', Decimal('0')),
+                    ])
+            self.assertEqual(numerics, [])
+
+            numerics = self.numeric.search([
+                    ('numeric', '!=', Decimal('1.1')),
+                    ])
+            self.assertEqual(numerics, [])
+
+            numerics = self.numeric.search([
+                    ('numeric', '!=', Decimal('0')),
+                    ])
+            self.assertEqual(numerics, [numeric1])
+
+            numerics = self.numeric.search([
+                    ('numeric', 'in', [Decimal('1.1')]),
+                    ])
+            self.assertEqual(numerics, [numeric1])
+
+            numerics = self.numeric.search([
+                    ('numeric', 'in', [Decimal('0')]),
+                    ])
+            self.assertEqual(numerics, [])
+
+            numerics = self.numeric.search([
+                    ('numeric', 'in', []),
+                    ])
+            self.assertEqual(numerics, [])
+
+            numerics = self.numeric.search([
+                    ('numeric', 'not in', [Decimal('1.1')]),
+                    ])
+            self.assertEqual(numerics, [])
+
+            numerics = self.numeric.search([
+                    ('numeric', 'not in', [Decimal('0')]),
+                    ])
+            self.assertEqual(numerics, [numeric1])
+
+            numerics = self.numeric.search([
+                    ('numeric', 'not in', []),
+                    ])
+            self.assertEqual(numerics, [numeric1])
+
+            numerics = self.numeric.search([
+                    ('numeric', '<', Decimal('5')),
+                    ])
+            self.assertEqual(numerics, [numeric1])
+
+            numerics = self.numeric.search([
+                    ('numeric', '<', Decimal('-5')),
+                    ])
+            self.assertEqual(numerics, [])
+
+            numerics = self.numeric.search([
+                    ('numeric', '<', Decimal('1.1')),
+                    ])
+            self.assertEqual(numerics, [])
+
+            numerics = self.numeric.search([
+                    ('numeric', '<=', Decimal('5')),
+                    ])
+            self.assertEqual(numerics, [numeric1])
+
+            numerics = self.numeric.search([
+                    ('numeric', '<=', Decimal('-5')),
+                    ])
+            self.assertEqual(numerics, [])
+
+            numerics = self.numeric.search([
+                    ('numeric', '<=', Decimal('1.1')),
+                    ])
+            self.assertEqual(numerics, [numeric1])
+
+            numerics = self.numeric.search([
+                    ('numeric', '>', Decimal('5')),
+                    ])
+            self.assertEqual(numerics, [])
+
+            numerics = self.numeric.search([
+                    ('numeric', '>', Decimal('-5')),
+                    ])
+            self.assertEqual(numerics, [numeric1])
+
+            numerics = self.numeric.search([
+                    ('numeric', '>', Decimal('1.1')),
+                    ])
+            self.assertEqual(numerics, [])
+
+            numerics = self.numeric.search([
+                    ('numeric', '>=', Decimal('5')),
+                    ])
+            self.assertEqual(numerics, [])
+
+            numerics = self.numeric.search([
+                    ('numeric', '>=', Decimal('-5')),
+                    ])
+            self.assertEqual(numerics, [numeric1])
+
+            numerics = self.numeric.search([
+                    ('numeric', '>=', Decimal('1.1')),
+                    ])
+            self.assertEqual(numerics, [numeric1])
+
+            numeric2 = self.numeric.create({
+                    'numeric': Decimal('0'),
+                    })
+            self.assert_(numeric2)
+            self.assertEqual(numeric2.numeric, Decimal('0'))
+
+            numerics = self.numeric.search([
+                    ('numeric', '=', Decimal('0')),
+                    ])
+            self.assertEqual(numerics, [numeric2])
+
+            numerics = self.numeric.search([
+                    ('numeric', 'in', [Decimal('0'), Decimal('1.1')]),
+                    ])
+            self.assertEqual(numerics, [numeric1, numeric2])
+
+            numerics = self.numeric.search([
+                    ('numeric', 'not in', [Decimal('0'), Decimal('1.1')]),
+                    ])
+            self.assertEqual(numerics, [])
+
+            numeric3 = self.numeric.create({})
+            self.assert_(numeric3)
+            self.assertEqual(numeric3.numeric, None)
+
+            numeric4 = self.numeric_default.create({})
+            self.assert_(numeric4)
+            self.assertEqual(numeric4.numeric, Decimal('5.5'))
+
+            self.numeric.write([numeric1], {
+                    'numeric': Decimal('0'),
+                    })
+            self.assertEqual(numeric1.numeric, Decimal('0'))
+
+            self.numeric.write([numeric2], {
+                    'numeric': Decimal('1.1'),
+                    })
+            self.assertEqual(numeric2.numeric, Decimal('1.1'))
+
+            self.assertRaises(Exception, self.numeric.create, {
+                    'numeric': 'test',
+                    })
+
+            self.assertRaises(Exception, self.numeric.write, [numeric1], {
+                    'numeric': 'test',
+                    })
 
             self.assertRaises(Exception, self.numeric_required.create, {})
             transaction.cursor.rollback()
 
-            numeric5_id = self.numeric_required.create({
+            numeric5 = self.numeric_required.create({
                     'numeric': Decimal(0),
                     })
-            numeric5 = self.numeric_required.read(numeric5_id)
-            self.assert_(numeric5['numeric'] == 0)
-
-            numeric6_id = self.numeric_digits.create({
-                'digits': 1,
-                'numeric': Decimal('1.1'),
-                })
-            self.assert_(numeric6_id)
-
-            self.failUnlessRaises(Exception, self.numeric_digits.create, {
-                'digits': 1,
-                'numeric': Decimal('1.11'),
-                })
-
-            self.failUnlessRaises(Exception, self.numeric_digits.write,
-                    numeric6_id, {
-                        'numeric': Decimal('1.11'),
-                        })
-
-            self.failUnlessRaises(Exception, self.numeric_digits.write,
-                    numeric6_id, {
-                        'numeric': Decimal('0.10000000000000001'),
-                        })
-
-            self.failUnlessRaises(Exception, self.numeric_digits.write,
-                    numeric6_id, {
-                        'digits': 0,
-                        })
-
-            numeric7_id = self.numeric.create({
-                'numeric': Decimal('0.1234567890123456789'),
-                })
-
-            numeric7 = self.numeric.read(numeric7_id, ['numeric'])
-            self.assert_(numeric7['numeric'] ==
-                    Decimal('0.1234567890123456789'))
+            self.assertEqual(numeric5.numeric, 0)
+
+            numeric6 = self.numeric_digits.create({
+                    'digits': 1,
+                    'numeric': Decimal('1.1'),
+                    })
+            self.assert_(numeric6)
+
+            self.assertRaises(Exception, self.numeric_digits.create, {
+                    'digits': 1,
+                    'numeric': Decimal('1.11'),
+                    })
+
+            self.assertRaises(Exception, self.numeric_digits.write,
+                [numeric6], {
+                    'numeric': Decimal('1.11'),
+                    })
+
+            self.assertRaises(Exception, self.numeric_digits.write,
+                [numeric6], {
+                    'numeric': Decimal('0.10000000000000001'),
+                    })
+
+            self.assertRaises(Exception, self.numeric_digits.write,
+                [numeric6], {
+                    'digits': 0,
+                    })
+
+            numeric7 = self.numeric.create({
+                    'numeric': Decimal('0.1234567890123456789'),
+                    })
+            self.assertEqual(numeric7.numeric,
+                Decimal('0.1234567890123456789'))
 
             transaction.cursor.rollback()
 
@@ -852,262 +806,249 @@
         '''
         with Transaction().start(DB_NAME, USER,
                 context=CONTEXT) as transaction:
-            for char in (self.char, self.char_translate):
-                char1_id = char.create({
+            for char in (self.char_translate, self.char):
+                char1 = char.create({
+                        'char': 'Test',
+                        })
+                self.assert_(char1)
+                self.assertEqual(char1.char, 'Test')
+
+                chars = char.search([
+                        ('char', '=', 'Test'),
+                        ])
+                self.assertEqual(chars, [char1])
+
+                chars = char.search([
+                        ('char', '=', 'Foo'),
+                        ])
+                self.assertEqual(chars, [])
+
+                chars = char.search([
+                        ('char', '=', None),
+                        ])
+                self.assertEqual(chars, [])
+
+                chars = char.search([
+                        ('char', '!=', 'Test'),
+                        ])
+                self.assertEqual(chars, [])
+
+                chars = char.search([
+                        ('char', '!=', 'Foo'),
+                        ])
+                self.assertEqual(chars, [char1])
+
+                chars = char.search([
+                        ('char', '!=', None),
+                        ])
+                self.assertEqual(chars, [char1])
+
+                chars = char.search([
+                        ('char', 'in', ['Test']),
+                        ])
+                self.assertEqual(chars, [char1])
+
+                chars = char.search([
+                        ('char', 'in', ['Foo']),
+                        ])
+                self.assertEqual(chars, [])
+
+                chars = char.search([
+                        ('char', 'in', [None]),
+                        ])
+                self.assertEqual(chars, [])
+
+                chars = char.search([
+                        ('char', 'in', []),
+                        ])
+                self.assertEqual(chars, [])
+
+                chars = char.search([
+                        ('char', 'not in', ['Test']),
+                        ])
+                self.assertEqual(chars, [])
+
+                chars = char.search([
+                        ('char', 'not in', ['Foo']),
+                        ])
+                self.assertEqual(chars, [char1])
+
+                chars = char.search([
+                        ('char', 'not in', [None]),
+                        ])
+                self.assertEqual(chars, [char1])
+
+                chars = char.search([
+                        ('char', 'not in', []),
+                        ])
+                self.assertEqual(chars, [char1])
+
+                chars = char.search([
+                        ('char', 'like', 'Test'),
+                        ])
+                self.assertEqual(chars, [char1])
+
+                chars = char.search([
+                        ('char', 'like', 'T%'),
+                        ])
+                self.assertEqual(chars, [char1])
+
+                chars = char.search([
+                        ('char', 'like', 'Foo'),
+                        ])
+                self.assertEqual(chars, [])
+
+                chars = char.search([
+                        ('char', 'like', 'F%'),
+                        ])
+                self.assertEqual(chars, [])
+
+                chars = char.search([
+                        ('char', 'ilike', 'test'),
+                        ])
+                self.assertEqual(chars, [char1])
+
+                chars = char.search([
+                        ('char', 'ilike', 't%'),
+                        ])
+                self.assertEqual(chars, [char1])
+
+                chars = char.search([
+                        ('char', 'ilike', 'foo'),
+                        ])
+                self.assertEqual(chars, [])
+
+                chars = char.search([
+                        ('char', 'ilike', 'f%'),
+                        ])
+                self.assertEqual(chars, [])
+
+                chars = char.search([
+                        ('char', 'not like', 'Test'),
+                        ])
+                self.assertEqual(chars, [])
+
+                chars = char.search([
+                        ('char', 'not like', 'T%'),
+                        ])
+                self.assertEqual(chars, [])
+
+                chars = char.search([
+                        ('char', 'not like', 'Foo'),
+                        ])
+                self.assertEqual(chars, [char1])
+
+                chars = char.search([
+                        ('char', 'not like', 'F%'),
+                        ])
+                self.assertEqual(chars, [char1])
+
+                chars = char.search([
+                        ('char', 'not ilike', 'test'),
+                        ])
+                self.assertEqual(chars, [])
+
+                chars = char.search([
+                        ('char', 'not ilike', 't%'),
+                        ])
+                self.assertEqual(chars, [])
+
+                chars = char.search([
+                        ('char', 'not ilike', 'foo'),
+                        ])
+                self.assertEqual(chars, [char1])
+
+                chars = char.search([
+                        ('char', 'not ilike', 'f%'),
+                        ])
+                self.assertEqual(chars, [char1])
+
+                char2 = char.create({
+                        'char': None,
+                        })
+                self.assert_(char2)
+                self.assertEqual(char2.char, None)
+
+                chars = char.search([
+                        ('char', '=', None),
+                        ])
+                self.assertEqual(chars, [char2])
+
+                chars = char.search([
+                        ('char', 'in', [None, 'Test']),
+                        ])
+                self.assertEqual(chars, [char1, char2])
+
+                chars = char.search([
+                        ('char', 'not in', [None, 'Test']),
+                        ])
+                self.assertEqual(chars, [])
+
+            char3 = self.char.create({})
+            self.assert_(char3)
+            self.assertEqual(char3.char, None)
+
+            char4 = self.char_default.create({})
+            self.assert_(char4)
+            self.assertEqual(char4.char, 'Test')
+
+            self.char.write([char1], {
+                    'char': None,
+                    })
+            self.assertEqual(char1.char, None)
+
+            self.char.write([char2], {
                     'char': 'Test',
                     })
-                self.assert_(char1_id)
-
-                char1 = char.read(char1_id, ['char'])
-                self.assert_(char1['char'] == 'Test')
-
-                char_ids = char.search([
-                    ('char', '=', 'Test'),
-                    ])
-                self.assert_(char_ids == [char1_id])
-
-                char_ids = char.search([
-                    ('char', '=', 'Foo'),
-                    ])
-                self.assert_(char_ids == [])
-
-                char_ids = char.search([
-                    ('char', '=', False),
-                    ])
-                self.assert_(char_ids == [])
-
-                char_ids = char.search([
-                    ('char', '!=', 'Test'),
-                    ])
-                self.assert_(char_ids == [])
-
-                char_ids = char.search([
-                    ('char', '!=', 'Foo'),
-                    ])
-                self.assert_(char_ids == [char1_id])
-
-                char_ids = char.search([
-                    ('char', '!=', False),
-                    ])
-                self.assert_(char_ids == [char1_id])
-
-                char_ids = char.search([
-                    ('char', 'in', ['Test']),
-                    ])
-                self.assert_(char_ids == [char1_id])
-
-                char_ids = char.search([
-                    ('char', 'in', ['Foo']),
-                    ])
-                self.assert_(char_ids == [])
-
-                char_ids = char.search([
-                    ('char', 'in', [False]),
-                    ])
-                self.assert_(char_ids == [])
-
-                char_ids = char.search([
-                    ('char', 'in', []),
-                    ])
-                self.assert_(char_ids == [])
-
-                char_ids = char.search([
-                    ('char', 'not in', ['Test']),
-                    ])
-                self.assert_(char_ids == [])
-
-                char_ids = char.search([
-                    ('char', 'not in', ['Foo']),
-                    ])
-                self.assert_(char_ids == [char1_id])
-
-                char_ids = char.search([
-                    ('char', 'not in', [False]),
-                    ])
-                self.assert_(char_ids == [char1_id])
-
-                char_ids = char.search([
-                    ('char', 'not in', []),
-                    ])
-                self.assert_(char_ids == [char1_id])
-
-                char_ids = char.search([
-                    ('char', 'like', 'Test'),
-                    ])
-                self.assert_(char_ids == [char1_id])
-
-                char_ids = char.search([
-                    ('char', 'like', 'T%'),
-                    ])
-                self.assert_(char_ids == [char1_id])
-
-                char_ids = char.search([
-                    ('char', 'like', 'Foo'),
-                    ])
-                self.assert_(char_ids == [])
-
-                char_ids = char.search([
-                    ('char', 'like', 'F%'),
-                    ])
-                self.assert_(char_ids == [])
-
-                char_ids = char.search([
-                    ('char', 'ilike', 'test'),
-                    ])
-                self.assert_(char_ids == [char1_id])
-
-                char_ids = char.search([
-                    ('char', 'ilike', 't%'),
-                    ])
-                self.assert_(char_ids == [char1_id])
-
-                char_ids = char.search([
-                    ('char', 'ilike', 'foo'),
-                    ])
-                self.assert_(char_ids == [])
-
-                char_ids = char.search([
-                    ('char', 'ilike', 'f%'),
-                    ])
-                self.assert_(char_ids == [])
-
-                char_ids = char.search([
-                    ('char', 'not like', 'Test'),
-                    ])
-                self.assert_(char_ids == [])
-
-                char_ids = char.search([
-                    ('char', 'not like', 'T%'),
-                    ])
-                self.assert_(char_ids == [])
-
-                char_ids = char.search([
-                    ('char', 'not like', 'Foo'),
-                    ])
-                self.assert_(char_ids == [char1_id])
-
-                char_ids = char.search([
-                    ('char', 'not like', 'F%'),
-                    ])
-                self.assert_(char_ids == [char1_id])
-
-                char_ids = char.search([
-                    ('char', 'not ilike', 'test'),
-                    ])
-                self.assert_(char_ids == [])
-
-                char_ids = char.search([
-                    ('char', 'not ilike', 't%'),
-                    ])
-                self.assert_(char_ids == [])
-
-                char_ids = char.search([
-                    ('char', 'not ilike', 'foo'),
-                    ])
-                self.assert_(char_ids == [char1_id])
-
-                char_ids = char.search([
-                    ('char', 'not ilike', 'f%'),
-                    ])
-                self.assert_(char_ids == [char1_id])
-
-                char2_id = char.create({
-                    'char': None,
-                    })
-                self.assert_(char2_id)
-
-                char2 = char.read(char2_id, ['char'])
-                self.assert_(char2['char'] == None)
-
-                char_ids = char.search([
-                    ('char', '=', False),
-                    ])
-                self.assert_(char_ids == [char2_id])
-
-                char_ids = char.search([
-                    ('char', 'in', [False, 'Test']),
-                    ])
-                self.assert_(char_ids == [char1_id, char2_id])
-
-                char_ids = char.search([
-                    ('char', 'not in', [False, 'Test']),
-                    ])
-                self.assert_(char_ids == [])
-
-            char3_id = self.char.create({})
-            self.assert_(char3_id)
-
-            char3 = self.char.read(char3_id, ['char'])
-            self.assert_(char3['char'] == None)
-
-            char4_id = self.char_default.create({})
-            self.assert_(char4_id)
-
-            char4 = self.char_default.read(char4_id, ['char'])
-            self.assert_(char4['char'] == 'Test')
-
-            self.char.write(char1_id, {
-                'char': None,
-                })
-            char1 = self.char.read(char1_id, ['char'])
-            self.assert_(char1['char'] == None)
-
-            self.char.write(char2_id, {
-                'char': 'Test',
-                })
-            char2 = self.char.read(char2_id, ['char'])
-            self.assert_(char2['char'] == 'Test')
-
-            self.failUnlessRaises(Exception, self.char_required.create, {})
+            self.assertEqual(char2.char, 'Test')
+
+            self.assertRaises(Exception, self.char_required.create, {})
             transaction.cursor.rollback()
 
-            self.failUnlessRaises(Exception, self.char_required.create, {
+            self.assertRaises(Exception, self.char_required.create, {
                     'char': '',
                     })
             transaction.cursor.rollback()
 
-            char5_id = self.char_required.create({
-                'char': 'Test',
-                })
-            self.assert_(char5_id)
-
-            char6_id = self.char_size.create({
-                'char': 'Test',
-                })
-            self.assert_(char6_id)
-
-            self.failUnlessRaises(Exception, self.char_size.create, {
-                'char': 'foobar',
-                })
-
-            self.failUnlessRaises(Exception, self.char_size.write, char6_id, {
-                'char': 'foobar',
-                })
+            char5 = self.char_required.create({
+                    'char': 'Test',
+                    })
+            self.assert_(char5)
+
+            char6 = self.char_size.create({
+                    'char': 'Test',
+                    })
+            self.assert_(char6)
+
+            self.assertRaises(Exception, self.char_size.create, {
+                    'char': 'foobar',
+                    })
+
+            self.assertRaises(Exception, self.char_size.write, [char6], {
+                    'char': 'foobar',
+                    })
             transaction.cursor.rollback()
 
-            char7_id = self.char.create({
-                'char': u'é',
-                })
-            self.assert_(char7_id)
-
-            char7 = self.char.read(char7_id, ['char'])
-            self.assert_(char7['char'] == u'é')
-
-            char_ids = self.char.search([
-                ('char', '=', u'é'),
-                ])
-            self.assert_(char_ids == [char7_id])
-
-            self.char.write(char7_id, {
-                'char': 'é',
-                })
-            char7 = self.char.read(char7_id, ['char'])
-            self.assert_(char7['char'] == u'é')
-
-            char_ids = self.char.search([
-                ('char', '=', 'é'),
-                ])
-            self.assert_(char_ids == [char7_id])
+            char7 = self.char.create({
+                    'char': u'é',
+                    })
+            self.assert_(char7)
+            self.assertEqual(char7.char, u'é')
+
+            chars = self.char.search([
+                    ('char', '=', u'é'),
+                    ])
+            self.assertEqual(chars, [char7])
+
+            self.char.write([char7], {
+                    'char': 'é',
+                    })
+            self.assertEqual(char7.char, u'é')
+
+            chars = self.char.search([
+                    ('char', '=', 'é'),
+                    ])
+            self.assertEqual(chars, [char7])
 
             transaction.cursor.rollback()
 
